diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/he-ppdu.h ns-3.39/src/wifi/model/he/he-ppdu.h
--- ns-3.38/src/wifi/model/he/he-ppdu.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/he-ppdu.h	2023-07-05 14:23:48.113428400 -0700
@@ -24,6 +24,8 @@
 
 #include "ns3/ofdm-ppdu.h"
 
+#include <variant>
+
 /**
  * \file
  * \ingroup wifi
@@ -33,6 +35,9 @@
 namespace ns3
 {
 
+/// HE SIG-B Content Channels
+constexpr size_t WIFI_MAX_NUM_HE_SIGB_CONTENT_CHANNELS = 2;
+
 class WifiPsdu;
 
 /**
@@ -44,109 +49,61 @@
 class HePpdu : public OfdmPpdu
 {
   public:
+    /// User Specific Fields in HE-SIG-Bs.
+    struct HeSigBUserSpecificField
+    {
+        uint16_t staId : 11; ///< STA-ID
+        uint8_t nss : 4;     ///< number of spatial streams
+        uint8_t mcs : 4;     ///< MCS index
+    };
+
+    /// HE SIG-B Content Channels
+    using HeSigBContentChannels = std::vector<std::vector<HeSigBUserSpecificField>>;
+
     /**
-     * HE-SIG PHY header (HE-SIG-A1/A2/B)
+     * HE-SIG PHY header for HE SU PPDUs (HE-SIG-A1/A2)
      */
-    class HeSigHeader : public Header
+    struct HeSuSigHeader
     {
-      public:
-        HeSigHeader();
+        uint8_t m_format{1};    ///< Format bit
+        uint8_t m_bssColor{0};  ///< BSS color field
+        uint8_t m_mcs{0};       ///< MCS field
+        uint8_t m_bandwidth{0}; ///< Bandwidth field
+        uint8_t m_giLtfSize{0}; ///< GI+LTF Size field
+        uint8_t m_nsts{0};      ///< NSTS
+    };                          // struct HeSuSigHeader
 
-        /**
-         * \brief Get the type ID.
-         * \return the object TypeId
-         */
-        static TypeId GetTypeId();
-
-        TypeId GetInstanceTypeId() const override;
-        void Print(std::ostream& os) const override;
-        uint32_t GetSerializedSize() const override;
-        void Serialize(Buffer::Iterator start) const override;
-        uint32_t Deserialize(Buffer::Iterator start) override;
-
-        /**
-         * Set the Multi-User (MU) flag.
-         *
-         * \param mu the MU flag
-         */
-        void SetMuFlag(bool mu);
-
-        /**
-         * Fill the MCS field of HE-SIG-A1.
-         *
-         * \param mcs the MCS field of HE-SIG-A1
-         */
-        void SetMcs(uint8_t mcs);
-        /**
-         * Return the MCS field of HE-SIG-A1.
-         *
-         * \return the MCS field of HE-SIG-A1
-         */
-        uint8_t GetMcs() const;
-        /**
-         * Fill the BSS Color field of HE-SIG-A1.
-         *
-         * \param bssColor the BSS Color value
-         */
-        void SetBssColor(uint8_t bssColor);
-        /**
-         * Return the BSS Color field in the HE-SIG-A1.
-         *
-         * \return the BSS Color field in the HE-SIG-A1
-         */
-        uint8_t GetBssColor() const;
-        /**
-         * Fill the channel width field of HE-SIG-A1 (in MHz).
-         *
-         * \param channelWidth the channel width (in MHz)
-         */
-        void SetChannelWidth(uint16_t channelWidth);
-        /**
-         * Return the channel width (in MHz).
-         *
-         * \return the channel width (in MHz)
-         */
-        uint16_t GetChannelWidth() const;
-        /**
-         * Fill the GI + LTF size field of HE-SIG-A1.
-         *
-         * \param gi the guard interval (in nanoseconds)
-         * \param ltf the sequence of HE-LTF
-         */
-        void SetGuardIntervalAndLtfSize(uint16_t gi, uint8_t ltf);
-        /**
-         * Return the guard interval (in nanoseconds).
-         *
-         * \return the guard interval (in nanoseconds)
-         */
-        uint16_t GetGuardInterval() const;
-        /**
-         * Fill the number of streams field of HE-SIG-A1.
-         *
-         * \param nStreams the number of streams
-         */
-        void SetNStreams(uint8_t nStreams);
-        /**
-         * Return the number of streams.
-         *
-         * \return the number of streams
-         */
-        uint8_t GetNStreams() const;
-
-      private:
-        // HE-SIG-A1 fields
-        uint8_t m_format;       ///< Format bit
-        uint8_t m_bssColor;     ///< BSS color field
-        uint8_t m_ul_dl;        ///< UL/DL bit
-        uint8_t m_mcs;          ///< MCS field
-        uint8_t m_spatialReuse; ///< Spatial Reuse field
-        uint8_t m_bandwidth;    ///< Bandwidth field
-        uint8_t m_gi_ltf_size;  ///< GI+LTF Size field
-        uint8_t m_nsts;         ///< NSTS
-
-        /// This is used to decide whether MU SIG-B should be added or not
-        bool m_mu;
-    }; // class HeSigHeader
+    /**
+     * HE-SIG PHY header for HE TB PPDUs (HE-SIG-A1/A2)
+     */
+    struct HeTbSigHeader
+    {
+        uint8_t m_format{0};    ///< Format bit
+        uint8_t m_bssColor{0};  ///< BSS color field
+        uint8_t m_bandwidth{0}; ///< Bandwidth field
+    };                          // struct HeTbSigHeader
+
+    /**
+     * HE-SIG PHY header for HE MU PPDUs (HE-SIG-A1/A2/B)
+     */
+    struct HeMuSigHeader
+    {
+        // HE-SIG-A fields
+        uint8_t m_bssColor{0};  ///< BSS color field
+        uint8_t m_bandwidth{0}; ///< Bandwidth field
+        uint8_t m_sigBMcs{0};   ///< HE-SIG-B MCS
+        uint8_t m_giLtfSize{0}; ///< GI+LTF Size field
+
+        // HE-SIG-B fields
+        RuAllocation m_ruAllocation; //!< RU allocations that are going to be carried in SIG-B
+                                     //!< common subfields
+        HeSigBContentChannels m_contentChannels; //!< HE SIG-B Content Channels
+        std::optional<Center26ToneRuIndication>
+            m_center26ToneRuIndication; //!< center 26 tone RU indication in SIG-B common subfields
+    };                                  // struct HeMuSigHeader
+
+    /// type of the HE-SIG PHY header
+    using HeSigHeader = std::variant<std::monostate, HeSuSigHeader, HeTbSigHeader, HeMuSigHeader>;
 
     /**
      * The transmit power spectral density flag, namely used
@@ -163,16 +120,14 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU
      */
     HePpdu(Ptr<const WifiPsdu> psdu,
            const WifiTxVector& txVector,
-           uint16_t txCenterFreq,
+           const WifiPhyOperatingChannel& channel,
            Time ppduDuration,
-           WifiPhyBand band,
            uint64_t uid);
     /**
      * Create an MU HE PPDU, storing a map of PSDUs.
@@ -181,17 +136,15 @@
      *
      * \param psdus the PHY payloads (PSDUs)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU or of the triggering PPDU if this is an HE TB PPDU
      * \param flag the flag indicating the type of Tx PSD to build
      */
     HePpdu(const WifiConstPsduMap& psdus,
            const WifiTxVector& txVector,
-           uint16_t txCenterFreq,
+           const WifiPhyOperatingChannel& channel,
            Time ppduDuration,
-           WifiPhyBand band,
            uint64_t uid,
            TxPsdFlag flag);
 
@@ -234,66 +187,111 @@
     void UpdateTxVectorForUlMu(const std::optional<WifiTxVector>& trigVector) const;
 
     /**
-     * Check if STA ID is in HE SIG-B Content Channel ID
-     * \param staId STA ID
-     * \param channelId Content Channel ID
-     * \return true if STA ID in content channel ID, false otherwise
+     * Get the number of RUs per HE-SIG-B content channel.
+     * This is applicable only for MU. MU-MIMO (i.e. multiple stations
+     * per RU) is not supported yet.
+     * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
+     *
+     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * \return a pair containing the number of RUs in each HE-SIG-B content channel (resp. 1 and 2)
+     */
+    static std::pair<std::size_t, std::size_t> GetNumRusPerHeSigBContentChannel(
+        uint16_t channelWidth,
+        const RuAllocation& ruAllocation);
+
+    /**
+     * Get the HE SIG-B content channels for a given PPDU
+     * IEEE 802.11ax-2021 27.3.11.8.2 HE-SIG-B content channels
+     *
+     * \param txVector the TXVECTOR used for the PPDU
+     * \param p20Index the index of the primary20 channel
+     * \return HE-SIG-B content channels
      */
-    bool IsStaInContentChannel(uint16_t staId, size_t channelId) const;
+    static HeSigBContentChannels GetHeSigBContentChannels(const WifiTxVector& txVector,
+                                                          uint8_t p20Index);
 
     /**
-     * Check if STA ID is allocated
-     * \param staId STA ID
-     * \return true if allocated, false otherwise
+     * Get variable length HE SIG-B field size
+     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * \return field size in bytes
      */
-    bool IsAllocated(uint16_t staId) const;
+    static uint32_t GetSigBFieldSize(uint16_t channelWidth, const RuAllocation& ruAllocation);
 
   protected:
     /**
      * Fill in the TXVECTOR from PHY headers.
      *
      * \param txVector the TXVECTOR to fill in
-     * \param lSig the L-SIG header
-     * \param heSig the HE-SIG header
      */
-    virtual void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
-                                           const LSigHeader& lSig,
-                                           const HeSigHeader& heSig) const;
+    virtual void SetTxVectorFromPhyHeaders(WifiTxVector& txVector) const;
 
-#ifndef NS3_BUILD_PROFILE_DEBUG
-    HeSigHeader m_heSig; //!< the HE-SIG PHY header
-#endif
-    mutable TxPsdFlag m_txPsdFlag; //!< the transmit power spectral density flag
+    /**
+     * Reconstruct HeMuUserInfoMap from HE-SIG-B header.
+     *
+     * \param txVector the TXVECTOR to set its HeMuUserInfoMap
+     * \param ruAllocation the RU_ALLOCATION per 20 MHz
+     * \param contentChannels the HE-SIG-B content channels
+     */
+    void SetHeMuUserInfos(WifiTxVector& txVector,
+                          const RuAllocation& ruAllocation,
+                          const HeSigBContentChannels& contentChannels) const;
 
-    WifiTxVector::HeMuUserInfoMap m_muUserInfos; //!< HE MU specific per-user information (to be
-                                                 //!< removed once HE-SIG-B headers are implemented)
-    ContentChannelAllocation
-        m_contentChannelAlloc; //!< HE SIG-B Content Channel allocation (to be removed once HE-SIG-B
-                               //!< headers are implemented)
-    RuAllocation m_ruAllocation; //!< RU_ALLOCATION in SIG-B common field (to be removed once
-                                 //!< HE-SIG-B headers are implemented)
+    /**
+     * Convert channel width expressed in MHz to bandwidth field encoding in HE-SIG-A.
+     *
+     * \param channelWidth the channel width in MHz
+     * \return the value used to encode the bandwidth field in HE-SIG-A
+     */
+    static uint8_t GetChannelWidthEncodingFromMhz(uint16_t channelWidth);
 
-  private:
-    std::string PrintPayload() const override;
-    WifiTxVector DoGetTxVector() const override;
+    /**
+     * Convert number of spatial streams to NSTS field encoding in HE-SIG-A.
+     *
+     * \param nss the number of spatial streams
+     * \return the value used to encode the NSTS field in HE-SIG-A
+     */
+    static uint8_t GetNstsEncodingFromNss(uint8_t nss);
 
     /**
-     * Return true if the PPDU is a MU PPDU
-     * \return true if the PPDU is a MU PPDU
+     * Convert guard interval (in ns) and NLTF to its encoding in HE-SIG-A.
+     *
+     * \param gi the guard interval in nanoseconds
+     * \param nltf the the number of long training symbols
+     * \return the value used to encode the NSTS field in HE-SIG-A
      */
-    virtual bool IsMu() const;
+    static uint8_t GetGuardIntervalAndNltfEncoding(uint16_t gi, uint8_t nltf);
 
     /**
-     * Return true if the PPDU is a DL MU PPDU
-     * \return true if the PPDU is a DL MU PPDU
+     * Convert number of spatial streams from NSTS field encoding in HE-SIG-A.
+     *
+     * \param nsts the value of the NSTS field in HE-SIG-A
+     * \return the number of spatial streams
      */
-    virtual bool IsDlMu() const;
+    static uint8_t GetNssFromNstsEncoding(uint8_t nsts);
 
     /**
-     * Return true if the PPDU is an UL MU PPDU
-     * \return true if the PPDU is an UL MU PPDU
+     * Convert channel width expressed in MHz from bandwidth field encoding in HE-SIG-A.
+     *
+     * \param bandwidth the value of the bandwidth field in HE-SIG-A
+     * \return the channel width in MHz
      */
-    virtual bool IsUlMu() const;
+    static uint16_t GetChannelWidthMhzFromEncoding(uint8_t bandwidth);
+
+    /**
+     * Convert guard interval (in ns) from its encoding in HE-SIG-A.
+     *
+     * \param giAndNltfSize the value used to encode the guard interval and NLTF field in HE-SIG-A
+     * \return the guard interval in nanoseconds
+     */
+    static uint16_t GetGuardIntervalFromEncoding(uint8_t giAndNltfSize);
+
+    mutable TxPsdFlag m_txPsdFlag; //!< the transmit power spectral density flag
+
+  private:
+    std::string PrintPayload() const override;
+    WifiTxVector DoGetTxVector() const override;
 
     /**
      * Fill in the PHY headers.
@@ -301,24 +299,42 @@
      * \param txVector the TXVECTOR that was used for this PPDU
      * \param ppduDuration the transmission duration of this PPDU
      */
-    virtual void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
+    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
 
     /**
      * Fill in the L-SIG header.
      *
-     * \param lSig the L-SIG header to fill in
      * \param ppduDuration the transmission duration of this PPDU
      */
-    virtual void SetLSigHeader(LSigHeader& lSig, Time ppduDuration) const;
+    void SetLSigHeader(Time ppduDuration);
 
     /**
      * Fill in the HE-SIG header.
      *
-     * \param heSig the HE-SIG header to fill in
      * \param txVector the TXVECTOR that was used for this PPDU
      */
-    void SetHeSigHeader(HeSigHeader& heSig, const WifiTxVector& txVector) const;
-}; // class HePpdu
+    void SetHeSigHeader(const WifiTxVector& txVector);
+
+    /**
+     * Return true if the PPDU is a MU PPDU
+     * \return true if the PPDU is a MU PPDU
+     */
+    virtual bool IsMu() const;
+
+    /**
+     * Return true if the PPDU is a DL MU PPDU
+     * \return true if the PPDU is a DL MU PPDU
+     */
+    virtual bool IsDlMu() const;
+
+    /**
+     * Return true if the PPDU is an UL MU PPDU
+     * \return true if the PPDU is an UL MU PPDU
+     */
+    virtual bool IsUlMu() const;
+
+    HeSigHeader m_heSig; //!< the HE-SIG PHY header
+};                       // class HePpdu
 
 /**
  * \brief Stream insertion operator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/he-ru.cc ns-3.39/src/wifi/model/he/he-ru.cc
--- ns-3.38/src/wifi/model/he/he-ru.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/he-ru.cc	2023-07-05 14:23:48.113428400 -0700
@@ -370,6 +370,24 @@
     // clang-format on
 };
 
+HeRu::RuSpecCompare::RuSpecCompare(uint16_t channelWidth, uint8_t p20Index)
+    : m_channelWidth(channelWidth),
+      m_p20Index(p20Index)
+{
+}
+
+bool
+HeRu::RuSpecCompare::operator()(const HeRu::RuSpec& lhs, const HeRu::RuSpec& rhs) const
+{
+    const auto lhsIndex = lhs.GetPhyIndex(m_channelWidth, m_p20Index);
+    const auto rhsIndex = rhs.GetPhyIndex(m_channelWidth, m_p20Index);
+    const auto lhsStartTone =
+        HeRu::GetSubcarrierGroup(m_channelWidth, lhs.GetRuType(), lhsIndex).front().first;
+    const auto rhsStartTone =
+        HeRu::GetSubcarrierGroup(m_channelWidth, rhs.GetRuType(), rhsIndex).front().first;
+    return lhsStartTone < rhsStartTone;
+}
+
 std::vector<HeRu::RuSpec>
 HeRu::GetRuSpecs(uint8_t ruAllocation)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/he-ru.h ns-3.39/src/wifi/model/he/he-ru.h
--- ns-3.38/src/wifi/model/he/he-ru.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/he-ru.h	2023-07-05 14:23:48.113428400 -0700
@@ -128,6 +128,34 @@
     };
 
     /**
+     * Struct providing a function call operator to compare two RUs.
+     */
+    struct RuSpecCompare
+    {
+        /**
+         * Constructor.
+         *
+         * \param channelWidth the channel width in MHz
+         * \param p20Index the index of the primary20 channel
+         */
+        RuSpecCompare(uint16_t channelWidth, uint8_t p20Index);
+        /**
+         * Function call operator.
+         *
+         * \param lhs left hand side RU
+         * \param rhs right hand side RU
+         * \return true if the left hand side RU has its leftmost tone at a lower
+         *         frequency than the leftmost tone of the right hand side RU,
+         *         false otherwise
+         */
+        bool operator()(const RuSpec& lhs, const RuSpec& rhs) const;
+
+      private:
+        uint16_t m_channelWidth; ///< The channel width in MHz
+        uint8_t m_p20Index;      ///< Primary20 channel index
+    };
+
+    /**
      * Get the number of distinct RUs of the given type (number of tones)
      * available in a HE PPDU of the given bandwidth.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/obss-pd-algorithm.cc ns-3.39/src/wifi/model/he/obss-pd-algorithm.cc
--- ns-3.38/src/wifi/model/he/obss-pd-algorithm.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/obss-pd-algorithm.cc	2023-07-05 14:23:48.113428400 -0700
@@ -19,9 +19,8 @@
 
 #include "obss-pd-algorithm.h"
 
-#include "he-phy.h"
-
 #include "ns3/double.h"
+#include "ns3/eht-phy.h"
 #include "ns3/log.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
@@ -85,6 +84,13 @@
 {
     NS_LOG_FUNCTION(this << device);
     m_device = device;
+    auto phy = device->GetPhy();
+    if (phy->GetStandard() >= WIFI_STANDARD_80211be)
+    {
+        auto ehtPhy = DynamicCast<EhtPhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_EHT));
+        NS_ASSERT(ehtPhy);
+        ehtPhy->SetObssPdAlgorithm(this);
+    }
     auto hePhy = DynamicCast<HePhy>(device->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
     NS_ASSERT(hePhy);
     hePhy->SetObssPdAlgorithm(this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.39/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.38/src/wifi/model/he/rr-multi-user-scheduler.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/he/rr-multi-user-scheduler.cc	2023-07-05 14:23:48.113428400 -0700
@@ -180,7 +180,7 @@
 
 template <class Func>
 WifiTxVector
-RrMultiUserScheduler::GetTxVectorForUlMu(Func canbeSolicited)
+RrMultiUserScheduler::GetTxVectorForUlMu(Func canBeSolicited)
 {
     NS_LOG_FUNCTION(this);
 
@@ -214,7 +214,7 @@
     {
         NS_LOG_DEBUG("Next candidate STA (MAC=" << staIt->address << ", AID=" << staIt->aid << ")");
 
-        if (!canbeSolicited(*staIt))
+        if (!canBeSolicited(*staIt))
         {
             NS_LOG_DEBUG("Skipping station based on provided function object");
             staIt++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ht/ht-capabilities.cc ns-3.39/src/wifi/model/ht/ht-capabilities.cc
--- ns-3.38/src/wifi/model/ht/ht-capabilities.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/ht/ht-capabilities.cc	2023-07-05 14:23:48.113428400 -0700
@@ -98,6 +98,17 @@
 }
 
 void
+HtCapabilities::Print(std::ostream& os) const
+{
+    os << "HT Capabilities=" << bool(GetLdpc()) << "|" << bool(GetSupportedChannelWidth()) << "|"
+       << bool(GetShortGuardInterval20()) << "|";
+    for (uint8_t i = 0; i < MAX_SUPPORTED_MCS; i++)
+    {
+        os << IsSupportedMcs(i) << " ";
+    }
+}
+
+void
 HtCapabilities::SetLdpc(uint8_t ldpc)
 {
     m_ldpc = ldpc;
@@ -222,11 +233,7 @@
 bool
 HtCapabilities::IsSupportedMcs(uint8_t mcs) const
 {
-    if (m_rxMcsBitmask[mcs] == 1)
-    {
-        return true;
-    }
-    return false;
+    return m_rxMcsBitmask[mcs] == 1;
 }
 
 uint8_t
@@ -238,7 +245,7 @@
 
         for (uint8_t mcs = (nRx - 1) * 8; mcs <= maxMcs; mcs++)
         {
-            if (IsSupportedMcs(mcs) == false)
+            if (!IsSupportedMcs(mcs))
             {
                 return (nRx - 1);
             }
@@ -506,16 +513,4 @@
     return length;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const HtCapabilities& htcapabilities)
-{
-    os << bool(htcapabilities.GetLdpc()) << "|" << bool(htcapabilities.GetSupportedChannelWidth())
-       << "|" << bool(htcapabilities.GetShortGuardInterval20()) << "|";
-    for (uint8_t i = 0; i < MAX_SUPPORTED_MCS; i++)
-    {
-        os << htcapabilities.IsSupportedMcs(i) << " ";
-    }
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ht/ht-capabilities.h ns-3.39/src/wifi/model/ht/ht-capabilities.h
--- ns-3.38/src/wifi/model/ht/ht-capabilities.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/ht/ht-capabilities.h	2023-07-05 14:23:48.113428400 -0700
@@ -271,6 +271,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     // HT Capabilities Info field
     uint8_t m_ldpc;                  ///< LDPC
@@ -322,8 +323,8 @@
     uint8_t m_implicitTxBfCapable;                  ///< implicit transmit BF capable
     uint8_t m_calibration;                          ///< calibration
     uint8_t m_explicitCsiTxBfCapable;               ///< explicit CSI transmit BF capable
-    uint8_t m_explicitNoncompressedSteeringCapable; ///< explicit non compressed steeering capable
-    uint8_t m_explicitCompressedSteeringCapable;    ///< explicit compressed steeering capable
+    uint8_t m_explicitNoncompressedSteeringCapable; ///< explicit non compressed steering capable
+    uint8_t m_explicitCompressedSteeringCapable;    ///< explicit compressed steering capable
     uint8_t m_explicitTxBfCsiFeedback;              ///< explicit transmit BF CSI feedback
     uint8_t
         m_explicitNoncompressedBfFeedbackCapable;  ///< explicit non compressed BF feedback capable
@@ -350,16 +351,6 @@
     uint8_t m_reservedASel;                             ///< reserved ASEL
 };
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param htcapabilities the HT capabilities
- *
- * \returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const HtCapabilities& htcapabilities);
-
 } // namespace ns3
 
 #endif /* HT_CAPABILITY_H */
